package org.vishia.MoneySim;

import java.io.IOException;

import org.vishia.msgDispatch.LogMessage;
import org.vishia.util.StringFunctions_C;

/**
 * This package specific class contains helper to evaluate some values and also print it out.
 */
class EvalAndShow {

  
  final LogMessage log;
  

  
  public EvalAndShow(LogMessage log) {
    super();
    this.log = log;
  }



  /**
   * Outputs two lines to log with the information about the amount and get money of one seller. 
   * @param allSeller
   * @throws IOException
   */
  void outSellerMoney ( SellerOnMarket[] allSeller) throws IOException {                              //
    StringBuilder sb0 = new StringBuilder("        Seller - money today: " );
    StringBuilder sb1 = new StringBuilder(" Seller - amount-start today: " );
    float amountSum =0, amountRest=0, moneySum=0;
    for(SellerOnMarket seller: allSeller) {
      StringFunctions_C.appendIntPict(sb0, (long)(seller.moneyOfDay), "| $22'221");
      StringFunctions_C.appendIntPict(sb1, (long)(seller.amountStart), "| 2221 kg");
      amountSum += seller.amountStart;
      amountRest += seller.amount;
      moneySum += seller.moneyOfDay;
    }
    this.log.writef("\n\n---------------------------------------------\n%s\n%s", sb1, sb0);
    float amountSelled = amountSum - amountRest;
    float amountSelledMean = amountSelled/allSeller.length;
    float priceMean = moneySum / amountSelled;
    float moneyMean = moneySum / allSeller.length;
    this.log.writef("\n  amount catch=%5.0f kg, rest=%5.0f kg, mean = %4.1f kg, money.mean = $%5.2f, price mean=$%2.2f"
                   , amountSum, amountRest, amountSelledMean, moneyMean, priceMean);
  }
      
  
  
  void outMeanFamilySituation(CityData city) {
    float[] wantToHaveSum = new float[city.families.length];
    float[] amountConsumed = new float[city.families.length];
    float[] money = new float[city.families.length];
    
    for(int ix1 = 0; ix1 < city.families.length; ++ix1) {
      Family[] families = city.families[ix1];
      for(Family family: families) {
        wantToHaveSum[ix1] += family.fish.wantToHave;
        amountConsumed[ix1] += family.fish.amountConsumed;
        money[ix1] += family.money;
      }
    }
    for(int ix1 = 0; ix1 < city.families.length; ++ix1) {
      float zFamilies = city.families[ix1].length;
      this.log.writef("\nFamily %s : wantToHaveFisch=%1.2f, amountConsumed=%2.1f,  money=$%4.2f"
          , city.families[ix1][0].comment, wantToHaveSum[ix1] / zFamilies, amountConsumed[ix1] / zFamilies, money[ix1] / zFamilies);
    }
  }

}
