package org.vishia.MoneySim;

/**This class describes one good which can be bought on the market.
 * 
 */
public class GoodFromMarket {
  String name;
  
  /**The buying behavior for this good.
   * Hint: The parameter may be also variable for deeper behavior simulation,
   * But for a simple simulation solution they are constants read from textual files. 
   */
  BuyingBehav buyingBehavior;
  
  /**
   * The nominal, expected and accepted price for one kg of the good.
   * This value is lower for poor people. Rich people buy for a higher price, expecting higher quality.
   */
  float nomPrice;
  
  
  
  /**
   * This factor describes how much of the unit of the good is need by this family per day,
   * but only after some days, see {@link #dayDiffNeed}
   * For example if it is a big family, it needs fish 1.5 kg per meal, but only each day in the week. 
   * Then this factor is 1.5. But per week =~ 0.22 is need, #dayDiffNeed = 7.
   */
  float amountPerUse;
  
  /**
   * This va lue describe how often a good is needed. For example fish for lunch, only one time per week.
   * Then this value is 7
   */
  int dayDiffNeed;
  
  /**
   * This is the current value for 'want to have' the good for the current day.
   * For example if there are one time in week to eat fisch, the next day this value is 0. 
   * Then it increases with the {@link #dayDiffNeed} reciprocal, so after {@link #dayDiffNeed} it is 1.0 again. 
   * But it increases further more if the good was not available.
   * If the price on the market is high, the good may not bought, then this value increases
   * and influences the willingness to buy the product also for a higher price.
   * It is sensible that this value growths not only linear. It can stay near 1.0 after the dayDiffNeed for a while.
   */
  float wantToHave;
  
  float amountConsumed;
}
